#NoTrayIcon
#Include <Array.au3>

$myRegX86 = 'HKEY_LOCAL_MACHINE\SOFTWARE\msbro\SoftwareInventory'
$myRegX64 = 'HKEY_LOCAL_MACHINE64\SOFTWARE\msbro\SoftwareInventory'
$myRegPath =''

If Not StringInStr(@OSArch, "X86") Then
   $myRegPath = $myRegX64
   Else
   $myRegPath = $myRegX86
EndIf

$Install = RegRead($myRegPath, "InventoryFilesInstallKey")
If Not StringInStr($Install, "yes") Then
   ConsoleWrite('NOT FOUND INSTALL KEY' & @CRLF)
   exit
Else

Dim  $aSoftwareInfo
LOCAL $my_ComputerName = @ComputerName
LOCAL $my_UserName = @UserName
LOCAL $my_Date = @YEAR&'-'&@MON&'-'&@MDAY
LOCAL $my_Time = @HOUR&'-'&@MIN&'-'&@SEC
LOCAL $my_Delay
LOCAL $Connect_SQL_String
EndIf

$Connect_SQL_String = RegRead($myRegPath, "Connect_SQL_String")
$my_Delay = RegRead($myRegPath, "Delay")

Sleep($my_Delay)

_ComputerGetSoftware($aSoftwareInfo)
;_ArrayDisplay($aSoftwareInfo)

Func _ComputerGetSoftware(ByRef $aSoftwareInfo)
   $ConnObj = ObjCreate("ADODB.Connection")
   $RezObj = ObjCreate("ADODB.Recordset")
   $ConnObj.Open($Connect_SQL_String)
   $RezObj.ActiveConnection = $ConnObj

    Local Const $UnInstKey  = "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall"
	Local Const $UnInstKey_User  = "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Uninstall"

    Local $i = 1
    Dim $aSoftwareInfo[1][10]

    While 1
        $AppKey = RegEnumKey($UnInstKey, $i)
        If @error <> 0 Then ExitLoop
        ReDim $aSoftwareInfo[UBound($aSoftwareInfo) + 1][10]
        $aSoftwareInfo[$i][0]   = StringStripWS(StringReplace(RegRead($UnInstKey & "\" & $AppKey, "DisplayName"), " (remove only)", ""), 3)
        $aSoftwareInfo[$i][1]   = StringStripWS(RegRead($UnInstKey & "\" & $AppKey, "DisplayVersion"), 3)
        $aSoftwareInfo[$i][2]   = StringStripWS(RegRead($UnInstKey & "\" & $AppKey, "Publisher"), 3)
        $aSoftwareInfo[$i][3]   = StringStripWS(RegRead($UnInstKey & "\" & $AppKey, "UninstallString"), 3)
		$aSoftwareInfo[$i][4]   = StringStripWS(RegRead($UnInstKey & "\" & $AppKey, "InstallDate"), 3)
		$aSoftwareInfo[$i][5]   = StringStripWS(RegRead($UnInstKey & "\" & $AppKey, "InstallSource"), 3)
		$aSoftwareInfo[$i][6]   = $my_ComputerName
		$aSoftwareInfo[$i][7]   = $my_UserName
		$aSoftwareInfo[$i][8]   = $my_Date
		$aSoftwareInfo[$i][9]   = $my_Time

		$sqlString = "INSERT INTO SoftwareInventory (DisplayName, DisplayVersion, Publisher,UninstallString,InstallDate,InstallSource,ComputerName,UserName,CheckDate,CheckTime) VALUES (N'"&$aSoftwareInfo[$i][0]&"', N'"&$aSoftwareInfo[$i][1]&"', N'"&$aSoftwareInfo[$i][2]&"',N'"&$aSoftwareInfo[$i][3]&"',N'"&$aSoftwareInfo[$i][4]&"',N'"&$aSoftwareInfo[$i][5]&"',N'"&$aSoftwareInfo[$i][6]&"',N'"&$aSoftwareInfo[$i][7]&"',N'"&$aSoftwareInfo[$i][8]&"',N'"&$aSoftwareInfo[$i][9]&"')"

		;ConsoleWrite('+++: ' & $aSoftwareInfo[$i][0] & '#####' &$aSoftwareInfo[$i][1] & '#####' &$aSoftwareInfo[$i][2] & '#####' &$aSoftwareInfo[$i][3] & @CRLF)
		$QueryRez = $RezObj.Open($sqlString)
		$i += 1
	 WEnd

    While 1
        $AppKey = RegEnumKey($UnInstKey_User, $i)
        If @error <> 0 Then ExitLoop
        ReDim $aSoftwareInfo[UBound($aSoftwareInfo) + 1][10]
        $aSoftwareInfo[$i][0]   = StringStripWS(StringReplace(RegRead($UnInstKey_User & "\" & $AppKey, "DisplayName"), " (remove only)", ""), 3)
        $aSoftwareInfo[$i][1]   = StringStripWS(RegRead($UnInstKey_User & "\" & $AppKey, "DisplayVersion"), 3)
        $aSoftwareInfo[$i][2]   = StringStripWS(RegRead($UnInstKey_User & "\" & $AppKey, "Publisher"), 3)
        $aSoftwareInfo[$i][3]   = StringStripWS(RegRead($UnInstKey_User & "\" & $AppKey, "UninstallString"), 3)
		$aSoftwareInfo[$i][4]   = StringStripWS(RegRead($UnInstKey_User & "\" & $AppKey, "InstallDate"), 3)
		$aSoftwareInfo[$i][5]   = StringStripWS(RegRead($UnInstKey_User & "\" & $AppKey, "InstallSource"), 3)
		$aSoftwareInfo[$i][6]   = $my_ComputerName
		$aSoftwareInfo[$i][7]   = $my_UserName
		$aSoftwareInfo[$i][8]   = $my_Date
		$aSoftwareInfo[$i][9]   = $my_Time

		$sqlString = "INSERT INTO SoftwareInventory (DisplayName, DisplayVersion, Publisher,UninstallString,InstallDate,InstallSource,ComputerName,UserName,CheckDate,CheckTime) VALUES (N'"&$aSoftwareInfo[$i][0]&"', N'"&$aSoftwareInfo[$i][1]&"', N'"&$aSoftwareInfo[$i][2]&"',N'"&$aSoftwareInfo[$i][3]&"',N'"&$aSoftwareInfo[$i][4]&"',N'"&$aSoftwareInfo[$i][5]&"',N'"&$aSoftwareInfo[$i][6]&"',N'"&$aSoftwareInfo[$i][7]&"',N'"&$aSoftwareInfo[$i][8]&"',N'"&$aSoftwareInfo[$i][9]&"')"

		;ConsoleWrite('+++: ' & $aSoftwareInfo[$i][0] & '#####' &$aSoftwareInfo[$i][1] & '#####' &$aSoftwareInfo[$i][2] & '#####' &$aSoftwareInfo[$i][3] & @CRLF)
		$QueryRez = $RezObj.Open($sqlString)

		$i += 1
	 WEnd

Sleep (500)
;удаляем пустые строки
$sqlString2 = "DELETE FROM SoftwareInventory WHERE DisplayName not like '%[a-z]%' and DisplayName not like '%[а-я]%' and CheckDate like '"&$my_Date&"' and ComputerName like '"&$my_ComputerName&"'"
$QueryRez2 = $RezObj.Open($sqlString2)

    $ConnObj.Close
    ConsoleWrite('END !!!' & @CRLF)
    $aSoftwareInfo[0][0] = UBound($aSoftwareInfo, 1) - 1

    If $aSoftwareInfo[0][0] < 1 Then
        SetError(1, 1, 0)
    EndIf
EndFunc
